
local _, TzTB = ...

-----------
-- Round --
-----------
local function Round( _value )
	return floor( _value + 0.5 )
end

--------------------------
-- TzTanaanBonus_OnLoad --
--------------------------
function TzTanaanBonus_OnLoad( _self )
	TzTB.frame = _self
end

--------------------------
-- WorldMapFrame_Update --
--------------------------
hooksecurefunc( "WorldMapFrame_Update", function()
	TzTanaanBonusIcons_Hide()

----------------------------------------------------------------
-- Bonus Objectives

	if TzTanaanBonusOptions.dailybonus_show then
		local db = TzTB.db[ "BonusObjectives" ]

		for _, entry in ipairs( db ) do
			if GetCurrentMapAreaID() == entry.areaID then
				local questCompleted = false

				for _, questID in ipairs( entry.questIDs ) do
					if questID ~= 0 and IsQuestFlaggedCompleted( questID ) then
						questCompleted = true
					end
				end

				if not questCompleted then
					for _, coord in ipairs( entry.coords ) do
						local icon = TzTanaanBonusIcons_Get( "interface/minimap/objecticons", 49, TzTanaanBonusOptions.dailybonus_scale, 0.5, 0.5, 1.0, 1.0 )
						local x = Round( ( coord[ 1 ] / 100 ) * WorldMapDetailFrame:GetWidth() )	-- Convert from TomTom
						local y = Round( ( coord[ 2 ] / 100 ) * WorldMapDetailFrame:GetHeight() )	-- Convert from TomTom
						local offset = TzTanaanBonusOptions.dailybonus_scale / 32.0

						icon.frame:SetPoint( "CENTER", WorldMapDetailFrame, "TOPLEFT", x - offset, -y - offset )
						icon.frame:Show()

						icon.image.text = format( "Bonus Objective: %s", entry.name )
						icon.image:SetPoint( "CENTER", WorldMapDetailFrame, "TOPLEFT", x, -y )
						icon.image:Show()
					end
				end
			end
		end
	end

----------------------------------------------------------------
-- Tiny Terrors

	if TzTanaanBonusOptions.tinyterrors_show then
		local db = TzTB.db[ "TinyTerrors" ]

		for _, entry in ipairs( db ) do
			if GetCurrentMapAreaID() == entry.areaID then
				local questCompleted = false

				for _, questID in ipairs( entry.questIDs ) do
					if questID ~= 0 and IsQuestFlaggedCompleted( questID ) then
						questCompleted = true
					end
				end

				if not questCompleted then
					for _, coord in ipairs( entry.coords ) do
						local icon = TzTanaanBonusIcons_Get( "interface/minimap/objecticons", 36, TzTanaanBonusOptions.tinyterrors_scale, 0.0, 1.0, 0.0, 1.0 )
						local x = Round( ( coord[ 1 ] / 100 ) * WorldMapDetailFrame:GetWidth() )	-- Convert from TomTom
						local y = Round( ( coord[ 2 ] / 100 ) * WorldMapDetailFrame:GetHeight() )	-- Convert from TomTom
						local offset = TzTanaanBonusOptions.tinyterrors_scale / 32.0

						icon.frame:SetPoint( "CENTER", WorldMapDetailFrame, "TOPLEFT", x - offset, -y - offset )
						icon.frame:Show()

						icon.image.text = format( "Tiny Terror: %s", entry.name )
						icon.image:SetPoint( "CENTER", WorldMapDetailFrame, "TOPLEFT", x, -y )
						icon.image:Show()
					end
				end
			end
		end
	end
end )
